function calcCumulativeDistances(locations){
    var distances = [];
    var totalDistance = 0;
    for (var i = 0; i < locations.length; i++) {
        if (i != 0)
            totalDistance += calcDistance(locations[i-1], locations[i]);
        distances.push(totalDistance); //don't push nextDistance, for charts we need cumulative distance
    }
    return distances;
}

function calcDistance(origin, destination) {
    var lng1 = origin.lng() * (Math.PI / 180);
    var lng2 = destination.lng() * (Math.PI / 180);

    var lat1 = origin.lat() * (Math.PI / 180);
    var lat2 = destination.lat() * (Math.PI / 180);

    var dis1 = Math.pow(Math.sin((lat2 - lat1) / 2), 2);
    var dis2 = Math.cos(lat1) * Math.cos(lat2) * Math.pow(Math.sin((lng2 - lng1) / 2), 2);

    var earthRadius = 6371;
    var distance = 2 * Math.asin(Math.sqrt(dis1 + dis2)) * earthRadius;

    return Math.round(distance); //in km
}

/*
function distance(lat1, lon1, lat2, lon2) {
    var R = 6371;
    var dLat = (lat2 - lat1) * Math.PI / 180;
    var dLon = (lon2 - lon1) * Math.PI / 180;
    var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) + Math.cos(lat1 * Math.PI / 180) * Math.cos(lat2 * Math.PI / 180) * Math.sin(dLon / 2) * Math.sin(dLon / 2);
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
    var d = R * c;

    if (d > 1)
        return Math.round(d) + " km";
    else if (d <= 1)
        return Math.round(d * 1000) + " m";
    return d
}
*/
