var _elevationsUpdatedCallback;

//openElevation.com
function getOpenElevationComPoint(lat, lng) {
    return {latitude: lat, longitude: lng};
}

//elevation-api.io
function getElevationApiIoPoint(lat, lng) {
    return [lat, lng];
}

function initElevations(elevationsUpdatedCallback) {
    _elevationsUpdatedCallback = elevationsUpdatedCallback;
}

function updateElevations(locations)
{
    //console.log('locations: ', JSON.stringify(locations));

    //(new google.maps.ElevationService()).getElevationAlongPath({'path': locations, 'samples': locations.length}, function(elevations, status) { loadElevations({evevations: elevations, status: status}); }); //Google Elevation API
    //return;

    var thePoints = [];

    var count = locations.length;
    for (var i=0; i < count; i++)
    {
        var point = locations[i]; //assume Google Maps path [{lat: function(){return ...}), lng: function(){return ...})}, ...]
        var lat = point.lat();
        var lng = point.lng();

        point = //getOpenElevationComPoint(lat, lng);
                getElevationApiIoPoint(lat, lng);
        //console.log('point: ', JSON.stringify(point));
        
        thePoints.push(point);
    }

    //console.log('Points: ', JSON.stringify(thePoints));

    //var requestData = JSON.stringify({locations : thePoints}); //Open-Elevation.com
    var requestData = JSON.stringify({points : thePoints}); //Elevation-api.io

    //console.log("JSON request data: %o", requestData);

    $.ajax({
          //url: "https://api.open-elevation.com/api/v1/lookup",
          url: "https://elevation-api.io/api/elevation?key=968F2l8f9V9o5b0Qpd-4s98qk9bU19",
          method: "POST",
          contentType: "application/json",
          dataType: "json",
          data: requestData
      })
      .done(loadElevations)

      .fail(function(err) {
          elevations = [];
          //alert(JSON.stringify(err));
          alert("Δεν είναι δυνατή η σύνδεση στην υπηρεσία υψομέτρου, ελέγξτε τη σύνδεσή σας στο διαδίκτυο");
      });
}

function loadElevations(response) {
    //console.log("Elevations: " + JSON.stringify(response));

    //open-elevation.com: { results: [{latitude:100, longitude:10, elevation:0}, ...] }
    //elevation-api.io: {elevations: [{lat:100, lon:10, elevation:0}, ...], resolution:"5000m" }
    //Google Maps API: { elevations: [{elevation: 1608.637939453125, location:{lat:39.73915360, lng:-104.98470340}, resolution:4.771975994110107}, ...], status="OK" }

    var elevations = [];

    // Extract elevation array from elevation-api.io result:
    var response_elevations = response.elevations;
    var count = response_elevations.length;
    for (var i = 0; i < count; i++)
        elevations[i] =  response_elevations[i].elevation;
    
    onElevationsUpdated(elevations);
}

function onElevationsUpdated(elevations) {
    if (_elevationsUpdatedCallback != null)
        _elevationsUpdatedCallback(elevations);
}
